package de.unikoblenz.fgbks.core.dmn.domain.vdmn.impl;

import de.unikoblenz.fgbks.core.dmn.domain.ids.DefinitionId;
import de.unikoblenz.fgbks.core.dmn.domain.vdmn.VDmnDecision;
import de.unikoblenz.fgbks.core.dmn.domain.vdmn.VDmnDefinition;
import java.util.ArrayList;
import java.util.List;
import org.apache.commons.lang3.Validate;

public class VDmnDefinitionImpl extends AbstractVDmnElement implements VDmnDefinition {

  private List<VDmnDecision> dmnDecisions;

  private VDmnDefinitionImpl() {
    dmnDecisions = new ArrayList<>();
  }

  @Override
  public List<VDmnDecision> getDmnDecisions() {
    return dmnDecisions;
  }

  public static Builder getBuilder() {
    return new VDmnDefinitionImpl().new Builder();
  }

  public class Builder extends DmnElementBuilder<VDmnDefinitionImpl> {

    public Builder withDefinitionId(DefinitionId definitionId) {
      value.id = definitionId;
      return this;
    }

    public Builder addDmnDecision(VDmnDecision dmnDecision) {
      value.dmnDecisions.add(Validate.notNull(dmnDecision));
      return this;
    }

    public Builder addDmnDecisionFromBuilder(VDmnDecisionImpl.Builder dmnDecisionBuilder) {
      addDmnDecision(dmnDecisionBuilder.getUnbuildValue());
      dmnDecisionBuilder.withDmnDefinition(value);
      return this;
    }

    @Override
    protected void validate() {
      super.validate();
      Validate.notNull(value.id);
    }
  }
}
