package de.unikoblenz.fgbks.core.dmn.utils;

import de.unikoblenz.fgbks.core.dmn.domain.vdmn.VDmnDefinition;
import de.unikoblenz.fgbks.core.dmn.domain.vdmn.parser.SimpleVDmnParser;
import java.nio.charset.Charset;
import java.util.List;
import javax.enterprise.context.ApplicationScoped;
import javax.inject.Inject;
import org.apache.commons.io.IOUtils;
import org.camunda.bpm.dmn.engine.DmnDecision;
import org.camunda.bpm.dmn.engine.DmnEngineConfiguration;
import org.camunda.bpm.model.dmn.DmnModelInstance;
import org.camunda.bpm.model.dmn.impl.DmnParser;

@ApplicationScoped
public class DmnService {

  @Inject SimpleVDmnParser simpleDmnParser;

  public DmnObjectContainer getDmnServiceFromXml(String dmnXmlString) {
    List<DmnDecision> dmnDecisions =
        DmnEngineConfiguration.createDefaultDmnEngineConfiguration()
            .buildEngine()
            .parseDecisions(IOUtils.toInputStream(dmnXmlString, Charset.defaultCharset()));
    DmnModelInstance dmnModel =
        new DmnParser()
            .parseModelFromStream(IOUtils.toInputStream(dmnXmlString, Charset.defaultCharset()));

    VDmnDefinition vDmnDefinition = simpleDmnParser.getVDmnDefinition(dmnModel);
    return new DmnObjectContainer(dmnDecisions, dmnModel, vDmnDefinition);
  }
}
